package ejbs;

import entities.Theatre;
import java.util.Collection;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

@Stateless
public class OneToOneBean implements OneToOneRemote {
    
    @PersistenceContext(unitName="one-to-one")
    EntityManager em;
    
    public OneToOneBean() {
    }
    
    public void persistEntity(Object entity) {
        em.persist(entity);
    }
    
    public void persistEntityCollection(Collection collection) {
        for(Object entity : collection){
            em.persist(entity);
        }
    }
    
    public Object findAndRefreshEntity(Class entityFromClass, Long id) {
        Object entity = em.find(entityFromClass, id);
        em.refresh(entity);
        return entity;
    }
    
    public Object findEntity(Class entityFromClass, Integer id) {
        return em.find(entityFromClass, id);
    }
    
    public Object findEntity(Class entityFromClass, Long id) {
        return em.find(entityFromClass, id);
    }
    
    public void removeEntity(Class entityFromClass, Long id) {
        Object entity = em.find(entityFromClass, id);
        em.remove(entity);
    }

    public Theatre findTheatreLoadLocation(Long id) {
        Theatre entity = em.find(Theatre.class, id);
        entity.getTheatreLocation();
        return entity;
    }

}
