package entities;

import java.io.Serializable;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;

@Entity
public class Theatre implements Serializable {

    private Long id;

    private TheatreLocation theatreLocation;
    private String theatreCode;
    
    public Theatre() {
    }

    @OneToOne(cascade=CascadeType.ALL, fetch=FetchType.EAGER, optional=true)
    @JoinColumn(name="LOCATION_ID")
    public TheatreLocation getTheatreLocation() {
        return theatreLocation;
    }

    public void setTheatreLocation(TheatreLocation theatreLocation) {
        this.theatreLocation = theatreLocation;
    }

    @Id
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public int hashCode() {
        int hash = 0;
        hash += (this.getId() != null ? this.getId().hashCode() : 0);
        return hash;
    }

    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Theatre)) {
            return false;
        }
        Theatre other = (Theatre)object;
        if (this.getId() != other.getId() && (this.getId() == null || !this.getId().equals(other.getId()))) return false;
        return true;
    }

    public String toString() {
        return "entities.alloverridden.Theatre[id=" + getId() + "]";
    }

    public String getTheatreCode() {
        return theatreCode;
    }

    public void setTheatreCode(String theatreCode) {
        this.theatreCode = theatreCode;
    }

}
