package tests.javaee;

import ejbs.OneToOneRemote;
import entities.Theatre;
import entities.TheatreLocation;
import javax.naming.InitialContext;

public class TestAllOverridden {
    
    private String testID;
    
    private static long LOC_ID = 87;
    private static String ADDRESS = "Knoxville, TN";
    private static long THEATRE_ID = 369;
    private static String CODE = "KTN";
    
    private static long THEATRE_ID2 = 94l;
    private static String CODE2 = "Lazy Theatre";
    private static long LOCATION_ID2 = 65l;
    private static String ADDRESS2 = "Lazy Load Town";
    
    private static long THEATRE_ID3 = 190l;
    private static String CODE3 = "Join Theatre";
    private static long LOCATION_ID3 = 88l;
    private static String ADDRESS3 = "Join Column Town";
    
    private OneToOneRemote remoteObj;
    
    public TestAllOverridden() {
    }
    
    public void tests() {
        try {
            remoteObj = (OneToOneRemote) new InitialContext().lookup("ejbs.OneToOneRemote");
            testFetchTypeOverrideLazyApplies();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private void testFetchTypeOverrideLazyApplies() {
        String testID = this.testID + ":FetchTypeOverrideLazyApplies";
        createAndPersistEntities(THEATRE_ID2, CODE2, LOCATION_ID2, ADDRESS2);
        assertLocationIsLazyLoadedOnLoadingTheatre(testID);
    }
    
    private void assertLocationIsLazyLoadedOnLoadingTheatre(String testID) {
        Theatre theatreWithoutLocation = (Theatre) remoteObj.findEntity(Theatre.class, THEATRE_ID2);
        if (locationLoaded(theatreWithoutLocation)) {
            System.out.println("*** Test Failed !! - Expected Lazy Loading of Theatre Location. It should not have loaded on loading Theatre.");
        } else {
            Theatre theatreWithLocation = (Theatre) remoteObj.findTheatreLoadLocation(THEATRE_ID2);
            if (theatreWithLocation.getTheatreLocation().getId() == LOCATION_ID2)
                System.out.println("*** Test Passed !!");
            else
                System.out.println("**** Test Failed -- Expected Theatre Location to be loaded successfully but Lazily;" +
                        " Expected location id - " + LOCATION_ID2 + ", Actual theatre location id - " + theatreWithLocation.getTheatreLocation().getId());
        }
    }
    
    private boolean locationLoaded(Theatre theatre) {
        try {
            // actually an exception is thrown if user tries to access a lazy field from a remote object.
            if (theatre.getTheatreLocation() != null)
                return true;
            else
                return false;
        } catch (Exception ex) {
            ex.printStackTrace();
            return false;
        }
    }
    
    private void createAndPersistEntities(long theatreID, String code, long locationID, String address) {
        Theatre theatre = createTheatre(theatreID, code);
        TheatreLocation location = createTheatreLocation(locationID, address);
        theatre.setTheatreLocation(location);
        location.setTheatre(theatre);
        
        remoteObj.persistEntity(theatre);
    }
    
    private Theatre createTheatre(long id, String code) {
        Theatre theatre = new Theatre();
        theatre.setId(id);
        theatre.setTheatreCode(code);
        return theatre;
    }
    
    private TheatreLocation createTheatreLocation(long id, String address) {
        TheatreLocation location = new TheatreLocation();
        location.setId(id);
        location.setAddress(address);
        return location;
    }
    
}
